﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Controls;

namespace BaseApplicationProject.Models
{
    public class MyViewModelBase : ViewModelBase
    {
        public MyViewModelBase()
        {
            this.isVisible = true;
        }

        private bool isVisible;
        public bool IsVisible
        {
            get
            {
                return this.isVisible;
            }
            set
            {
                if (this.isVisible != value)
                {
                    this.isVisible = value;
                    OnPropertyChanged("IsVisible");
                }
            }
        }
        
    }

    public class AssessmentViewModel : MyViewModelBase
    {
        public AssessmentViewModel()
        {
            this.QuestionGroupViewModels = new ObservableCollection<QuestionGroupViewModel>();
        }

        public string AssessmentTitle { get; set; }

        public ObservableCollection<QuestionGroupViewModel> QuestionGroupViewModels { get; set; }
    }

    public class QuestionGroupViewModel : MyViewModelBase
    {
        public QuestionGroupViewModel()
        {
            this.QuestionViewModels = new ObservableCollection<QuestionViewModel>();
            this.ChildQuestionGroupViewModels = new ObservableCollection<QuestionGroupViewModel>();
        }

        public string GroupTitle { get; set; }

        public ObservableCollection<QuestionViewModel> QuestionViewModels { get; set; }
           public ObservableCollection<QuestionGroupViewModel> ChildQuestionGroupViewModels { get; set; }
    }

    public class QuestionViewModel : MyViewModelBase
    {
        public string Title { get; set; }
    }

    public class MainViewModel
    {
        public ObservableCollection<AssessmentViewModel> Items { get; set; }

        public MainViewModel()
        {
            this.Items = new ObservableCollection<AssessmentViewModel>();
            for (int i = 0; i < 4; i++)
            {
                var assessmentItem = new AssessmentViewModel() { AssessmentTitle = "Assessment " + i };
                for (int j = 0; j < 2; j++)
                {
                    var questionGroup = new QuestionGroupViewModel() { GroupTitle = "Group " + j };
                    for (int k = 0; k < 2; k++)
                    {
                        var question = new QuestionViewModel() { Title = "Question " + k };

                        if (j == 1)
                        {
                            var subGroup = new QuestionGroupViewModel() { GroupTitle = "Sub Group " + k };
                            questionGroup.ChildQuestionGroupViewModels.Add(subGroup);
                        }
                        questionGroup.QuestionViewModels.Add(question);
                    }
                    assessmentItem.QuestionGroupViewModels.Add(questionGroup);
                }
                this.Items.Add(assessmentItem);
             }

            this.Items[0].QuestionGroupViewModels[0].QuestionViewModels[0].IsVisible = false;
        }
    }

}
